/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package controller;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.List;
import java.util.Random;
import model.Game;
import model.Player;

/**
 *
 * @author s2655314
 */
public class Controller {
    
    private Game game;
    private Player actualPlayer;
    private Player previousPlayer;
    private int actualCardTransaction;
    private boolean newGame;

    public Controller() {
    }
    
    public void initGame(){
        game = new Game();
        this.actualPlayer = game.getPlayers().get(0);
        this.newGame=true;
        this.actualCardTransaction = 0;
    }
    
    public void restartGame(){
        initGame();
    }
    
    public String nextTurn(){
        Player previousFromPreviousPlayer = this.previousPlayer;
        this.previousPlayer = this.actualPlayer;
        this.actualPlayer = nextPlayer();
        System.out.println(this.actualPlayer.getName());
        this.game.removeLastPlayerSignal(this.actualPlayer);
        int previousCardTransaction = this.actualCardTransaction;
        List<Integer> cardTransaction = chooseCard(this.actualPlayer);
        this.actualCardTransaction = cardTransaction.get(0);
        updateknowledge(cardTransaction, game.getPlayers(), this.previousPlayer, previousFromPreviousPlayer, previousCardTransaction);        
        String kempsReaction = this.game.kempsReaction(this.actualPlayer);
            System.out.println(kempsReaction);
        if (!kempsReaction.equals("nothing")){
            String result = kempsReactionResult(this.actualPlayer, kempsReaction);
            System.out.println("TEST");
            return result;
        }
        else
            giveSignal(actualPlayer);
        return kempsReaction;
    }
    
    /*public void previousTurn(){
        this.actualPlayer = previousPlayer();
        List<Integer> cardTransaction = chooseCard(actualPlayer);
        updateknowledge(cardTransaction, game.getPlayers());
        //kempsTurn(previousPlayer(),actualPlayer,nextPlayer());
    }*/
    
    public Hashtable<String, ArrayList<Integer>> updateCards(){
        Hashtable<String, ArrayList<Integer>> cardsToUpdate= new Hashtable();
        return cardsToUpdate;
    }
    
    private Player nextPlayer(){
        if (this.newGame==true){
            this.newGame=false;
            return this.game.getPlayers().get(0);
        }
        else if (actualPlayer.getName().equals(game.getPlayers().get(3).getName()))
            return game.getPlayers().get(0);
        return game.getPlayers().get(game.getPlayers().indexOf(actualPlayer)+1);
    }
    
    private Player nextPlayer(Player current){
        if (current.getName().equals(game.getPlayers().get(3).getName()))
            return game.getPlayers().get(0);
        return game.getPlayers().get(game.getPlayers().indexOf(current)+1);
    }
    
    private Player previousPlayer(){
        if (actualPlayer.getName().equals(game.getPlayers().get(0).getName()))
            return game.getPlayers().get(this.game.getN_players()-1);
        return game.getPlayers().get(game.getPlayers().indexOf(actualPlayer)-1);
    }
    
    private boolean isFirstPlayer(Player p){
        return (p.getName().equals(game.getPlayers().get(1).getName()) || p.getName().equals(game.getPlayers().get(3).getName()));
    }
    /**
     * 
     * @param actualPlayer
     * @return Return two Integer in a list, 
     * - the first represent the card that is given to the table by the player
     * - the second is the card chosen by de player 
     */
    private List<Integer> chooseCard(Player actualPlayer) {
        //Random rnd = new Random();
        //int indexA = rnd.nextInt(1);
        //int indexB = rnd.nextInt(1);
        
        int[] index = getSwapCards(actualPlayer);
        
        int playerCard =  this.actualPlayer.getCards().get(index[0]);
        int tableCard = this.game.getTable().getCards().get(index[1]);
        
        
        this.actualPlayer.getCards().remove(index[0]);
        this.actualPlayer.getCards().add(tableCard);
        this.game.getTable().getCards().remove(index[1]);
        this.game.getTable().getCards().add(playerCard);
        List<Integer> cardTransaction = Arrays.asList(playerCard, tableCard);
        return cardTransaction;
    }
    
    private int [] getSwapCards(Player actualPlayer){
        // actionPriority keeps track of the action that should get priority
        double actionPriority [][] = {{0,0},{0,0}};
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < 2; j++) {
                int playerCard = actualPlayer.getCards().get(i);
                int tableCard = this.game.getTable().getCards().get(j);
                if(isFirstPlayer(actualPlayer)){
                    // Maximize own kemps
                    if(playerCard == tableCard){
                        actionPriority[(i+1)%2][j] += 10;
                    }
                    // Minimize next player kemps
                    actionPriority[i][j] -= 5 * kempsProbAfterSwap(actualPlayer,nextPlayer(actualPlayer),new int[] {playerCard,this.game.getTable().getCards().get((j+1)%2)});
                    // Minimize next next player kemps
                    actionPriority[i][j] -= 3 * kempsProbAfterSwap(actualPlayer,nextPlayer(nextPlayer(actualPlayer)),new int[] {playerCard,this.game.getTable().getCards().get((j+1)%2)});
                    // Minimize next next next player kemps
                    actionPriority[i][j] += kempsProbAfterSwap(actualPlayer,nextPlayer(nextPlayer(nextPlayer(actualPlayer))),new int[] {playerCard,this.game.getTable().getCards().get((j+1)%2)});
                } else {
                    // Minimize own kemps
                    if(playerCard == tableCard){
                        actionPriority[(i+1)%2][j] -= 10;
                    }
                    // Minimize next player kemps
                    actionPriority[i][j] -= 5 * kempsProbAfterSwap(actualPlayer,nextPlayer(actualPlayer),new int[] {playerCard,this.game.getTable().getCards().get((j+1)%2)});
                    // Maximize next next player kemps
                    actionPriority[i][j] += 3 * kempsProbAfterSwap(actualPlayer,nextPlayer(nextPlayer(actualPlayer)),new int[] {playerCard,this.game.getTable().getCards().get((j+1)%2)});
                    // Maximize next next next player kemps
                    actionPriority[i][j] += kempsProbAfterSwap(actualPlayer,nextPlayer(nextPlayer(nextPlayer(actualPlayer))),new int[] {playerCard,this.game.getTable().getCards().get((j+1)%2)});
                }
            }
        }
        
        return getMaxPriorityIdx(actionPriority);
    }
    
    // calculates the probability that kempsPlayer gets kemps assuming that cards are the cards on the table when it's kempsPlayer's turn
    private double kempsProbAfterSwap(Player currentPlayer, Player kempsPlayer, int[] cards){
        int total = 0;
        double kemps = 0;
        double prob;
        for(List<Integer> k : currentPlayer.getKnowledge().get(kempsPlayer.getName())){
            if(k.get(0)==cards[0] || k.get(0)==cards[1] || k.get(1)==cards[0] || k.get(1)==cards[1])
                kemps++;
            total++;
        }
        prob = (double)kemps/(double)total;
        //System.out.println(prob);
        return prob;
    }
    
    private int [] getMaxPriorityIdx(double[][] array){
        int max_idx_x = 0, max_idx_y = 0;
        for(int i=0; i < array.length; i++){
            for(int j=0; j< array[i].length; j++){
                if(array[i][j] > array[max_idx_x][max_idx_y]){
                    max_idx_x = i;
                    max_idx_y = j;
                }
            }
        }
        return new int[] {max_idx_x, max_idx_y};
    }

private void updateknowledge(List<Integer> cardTransaction, ArrayList<Player> players, Player previousPlayer,Player previousFromPreviousPlayer, int previousCardTransaction) {
        Player playerToUdate;
        int indexPlayerToUpdate = game.getPlayers().indexOf(actualPlayer)+2;
        if (indexPlayerToUpdate>=this.game.getN_players())
            indexPlayerToUpdate = indexPlayerToUpdate%this.game.getN_players();
        playerToUdate = this.game.getPlayers().get(indexPlayerToUpdate);
        this.game.updatePlayerknowledge(previousFromPreviousPlayer, previousPlayer, actualPlayer, playerToUdate, cardTransaction, previousCardTransaction);
    }

    private void giveSignal(Player actualPlayer) {
        if (this.actualPlayer.hasPair())
                this.game.playersayKempSignal(this.actualPlayer);
        else if (actualPlayer.thinkForBluffing(this.game.getOponents(this.actualPlayer)))
                this.game.playerBluffKemps(actualPlayer);
        else if (actualPlayer.randomBluffing())
                this.game.playerBluffKemps(this.actualPlayer);
        
    }

    public Game getGame() {
        return game;
    }

    public Player getActualPlayer() {
        return actualPlayer;
    }

    //The actual player can call for kemps in 3 cases: When he has a pair, when he thinks that the opponent thinks that he has a pair and in a random moment.
    /*private boolean callForKemps(Player actualPlayer) {
        if (actualPlayer.hasPair())
            System.out.println("");
        return true;
    }

    private void callForKempsReaction(Player previousPlayer, Player nextPlayer) {
        System.out.println("");
    }*/

    private void printStatus(List<Integer> cardTransaction) {
        System.out.println(this.actualPlayer.getName()+" "+cardTransaction.get(1));

    }

    private String kempsReactionResult(Player actualPlayer, String kempsReaction) {
        if (kempsReaction.equals("kemps")){
            System.out.println("-----------INIT");
            System.out.println("Actual"+this.getActualPlayer().getName());
            System.out.println("Partnet"+this.getGame().getPartner(this.getActualPlayer()).getName());
            System.out.println(this.game.getPartner(this.actualPlayer).hasPair());
            System.out.println("-----------END");
            if (this.game.getPartner(this.actualPlayer).hasPair())
                return "win";
            else
                return "lose";
        }
        else if (kempsReaction.equals("antiKemps")){
            if (this.game.getOponents(this.actualPlayer).get(0).hasPair())
                return "win";
            else if (this.game.getOponents(this.actualPlayer).get(1).hasPair())
                return "win";
            else
                return "lose";
        }   
        return "lose";
    }
    
    public ArrayList<List<Integer>> getFilteredKnowledge(Player p, String name){
        return this.game.filterDuplicateds(p.getKnowledge().get(name));
    }
    
}
