package model;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Hashtable;
import java.util.List;
import org.paukov.combinatorics.Factory;
import org.paukov.combinatorics.Generator;
import org.paukov.combinatorics.ICombinatoricsVector;
import org.paukov.combinatorics.combination.simple.SimpleCombinationGenerator;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author s2655314
 */
public class Game {
    
    private ArrayList<Integer> cards;
    private ArrayList<Player> players;
    private Table table;
    private int cardsNumber;
    private int cardsAmount;
    private int n_players;
    private Hashtable<String, String> signals;
    private Hashtable<String, String> kempsCall;
    private final String KEMPS = "kemps";
    private final String ANTI_KEMPS = "antiKemps";
    private final String NOTHING = "nothing";

    public Game() {
  this.cardsNumber = 5;
        this.cardsAmount = 10;
        this.n_players=4;

        this.cards = new ArrayList(cardsNumber);
        for (int i =1; i<=cardsNumber; i++){
            this.cards.add(i);
            this.cards.add(i);
        }
        this.table = new Table();
        this.players = new ArrayList(n_players);
        this.signals = new Hashtable<String, String>();
        this.kempsCall = new Hashtable<String, String>();
        for (int i = 1; i<=n_players; i++){
            if (i==1 || i==4)
                this.players.add(new Player(Integer.toString(i), "Tomato"));
            else
                this.players.add(new Player(Integer.toString(i), "Potato"));
            String playerName = "Player"+Integer.toString(i);
            this.signals.put(playerName, "None");
            this.kempsCall.put(playerName, "None");

        }
        this.startGame();
    }
    
    public void cardsAssigment(){
        int cardCounter=0;
        Collections.shuffle(this.cards);
        for (Player p : players){
            p.getCards().add(this.cards.get(cardCounter));
            cardCounter++;
            p.getCards().add(this.cards.get(cardCounter));
            cardCounter++;
        }
        this.table.getCards().add(this.cards.get(cardCounter));
        cardCounter++;
        this.table.getCards().add(this.cards.get(cardCounter));
        cardCounter++;
    }
    
    public void initKnowledgeAssigment(){
                    
                    
        //For each player, we add a knowledge for what cards the other players have.
        //So this knowledge, will be the permutations of all cards minus the owners cards and the table cards
        ArrayList<List<Integer>> combinatoriArray = new ArrayList();

        for (Player pA : this.players){
            
            /*Table knowleadge init first player
            if (pA.getName().equals( this.getPlayers().get(0).getName())){
                ArrayList<List<Integer>> initActualPlayerTableKnowledge = new ArrayList();
                initActualPlayerTableKnowledge.add(Arrays.asList(this.getTable().getCards().get(0),(this.getTable().getCards().get(1))));
                pA.getKnowledge().put("Table", new ArrayList<List<Integer>>(initActualPlayerTableKnowledge));
            }
            else{
                //Table knowleadge init
                ArrayList<List<Integer>> initTableKnowledge = new ArrayList();
                initTableKnowledge.add(Arrays.asList(0,0));
                pA.getKnowledge().put("Table", new ArrayList<List<Integer>>(initTableKnowledge));
                    }*/

            
            
            //Each player has de the same own knowledge for the rest of them (the modul calc then is for compare always diferent players)
            combinatoriArray = getCombinatory(pA, this.players.get((this.players.indexOf(pA)+2)%3));
            //Adding the own cards players knowledge
            for (Player pB : this.players){
                if (pA==pB){
                    ArrayList<List<Integer>> cardsKnowledge = new ArrayList();
                    cardsKnowledge.add(pA.getCards());
                    pA.getKnowledge().put(pA.getName(), cardsKnowledge);
                }
                else{
                    //Adding initial knowledge about the other players
                    pA.getKnowledge().put(pB.getName(), combinatoriArray);
                    pA.getKnowledge().put("Table", combinatoriArray);

                }
            }
        }
        //printKnowledge(this.players.get(0));
  }   
    
    public void initSeenCards(){
        for (Player pA : this.players){
            for (Player pB : this.players){
                 if (pA!=pB){
                    pA.getSeenCards().put(pB.getName(), Arrays.asList(0, 0));
                 }
                 else{
                     pA.getSeenCards().put(pB.getName(), pB.getCards());
                 }
            }
            pA.getSeenCards().put("Table", Arrays.asList(0, 0));
        }
        

    }


    //Just a test method
    private void printKnowledge(Player p){
        System.out.print(p.getName()+":");
        Utils.printHashTable(p.getKnowledge());
    }
    //Just a test method
    private void printSeenCards(Player p){
        System.out.print(p.getName()+":");
        Utils.printHashTable(p.getSeenCards());
    }
    
     //Just a test method
    private void printAllPlayersKnowledge(){
        for (Player p : this.getPlayers()){
            printKnowledge(p);
            System.out.print("\n");
        }
    }
    //Just a test method
    private void printAllPlayersSeenCards(){
        for (Player p : this.getPlayers()){
            printSeenCards(p);
            System.out.print("\n");
        }
    }   
    
    public void startGame(){
        this.cardsAssigment();
        this.initSeenCards();
        this.initKnowledgeAssigment();
    }


    public ArrayList<Integer> getCards() {
        return cards;
    }

    public ArrayList<Player> getPlayers() {
        return players;
    }

    public Table getTable() {
        return table;
    }

    public int getCardsNumber() {
        return cardsNumber;
    }

    public int getCardsAmount() {
        return cardsAmount;
    }

    public int getN_players() {
        return n_players;
    }

 public void updatePlayerknowledge(Player previousFromPreviousPlayer, Player previousPlayer, Player actualPlayer, Player playerToUdate, List<Integer> cardsTransaccion, Integer previousCardTransaction) {
        /*if (previousPlayer!=null){
            ArrayList<List<Integer>> tableCombinatory = getCombinatory(previousPlayer, actualPlayer);
            previousPlayer.getSeenCards().get("Table").set(0, 0);
            previousPlayer.getSeenCards().get("Table").set(0, 0);
            previousPlayer.getKnowledge().remove("Table");
            previousPlayer.getKnowledge().put("Table", tableCombinatory);
           for (Player p : this.players){
                if (!p.getName().equals(previousPlayer.getName())){
                    ArrayList<List<Integer>> combinatory = getCombinatory(previousPlayer, p);
                    previousPlayer.getKnowledge().remove(p.getName());
                    previousPlayer.getKnowledge().put(p.getName(), combinatory);
                }  
           }
        }
        if (previousFromPreviousPlayer!=null){
            
        }*/
        
        if (previousPlayer!=null){
            ArrayList<List<Integer>> tableCombinatory = getCombinatory(previousPlayer, actualPlayer);
            //System.out.println("TEST"+ previousCardTransaction);
            previousPlayer.getSeenCards().get("Table").set(0, previousCardTransaction);
            previousPlayer.getSeenCards().get("Table").set(1, 0);
            previousPlayer.getKnowledge().remove("Table");
            previousPlayer.getKnowledge().put("Table", tableCombinatory);             
           for (Player p : this.players){
                if (!p.getName().equals(previousPlayer.getName())){
                    ArrayList<List<Integer>> combinatory = getCombinatory(previousPlayer, p);
                    previousPlayer.getKnowledge().remove(p.getName());
                    previousPlayer.getKnowledge().put(p.getName(), combinatory);
                }  
           }
        }
        if (previousFromPreviousPlayer!=null){
            ArrayList<List<Integer>> tableCombinatory = getCombinatory(previousPlayer, actualPlayer);
            previousFromPreviousPlayer.getSeenCards().get("Table").set(0, 0);
            previousFromPreviousPlayer.getSeenCards().get("Table").set(1, 0);
            previousFromPreviousPlayer.getKnowledge().remove("Table");
            previousFromPreviousPlayer.getKnowledge().put("Table", tableCombinatory);
           for (Player p : this.players){
                if (!p.getName().equals(previousFromPreviousPlayer.getName())){
                    ArrayList<List<Integer>> combinatory = getCombinatory(previousFromPreviousPlayer, p);
                    previousFromPreviousPlayer.getKnowledge().remove(p.getName());
                    previousFromPreviousPlayer.getKnowledge().put(p.getName(), combinatory);
                }  
           }         
        }
        
        playerToUdate.addWatchedCard(cardsTransaccion, actualPlayer);
        actualPlayer.getSeenCards().get("Table").set(0, this.getTable().getCards().get(0));
        actualPlayer.getSeenCards().get("Table").set(0, this.getTable().getCards().get(1));
        //Table knowleadge update
        ArrayList<List<Integer>> tableKnowledge = new ArrayList();
        tableKnowledge.add(this.getTable().getCards());
        actualPlayer.getKnowledge().remove("Table");
        ArrayList<List<Integer>> initTableKnowledge = new ArrayList();
        initTableKnowledge.add(Arrays.asList(0,0));
        actualPlayer.getKnowledge().put("Table", new ArrayList<List<Integer>>(initTableKnowledge));
        actualPlayer.getKnowledge().get("Table").set(0, Arrays.asList(this.getTable().getCards().get(0), this.getTable().getCards().get(1)));
        //Update actual player knowledge
        for (Player p : this.players){
            if (!p.getName().equals(actualPlayer.getName())){
                ArrayList<List<Integer>> combinatory = getCombinatory(actualPlayer, p);
                actualPlayer.getKnowledge().remove(p.getName());
                actualPlayer.getKnowledge().put(p.getName(), combinatory);
            }
            //Update oposite player knowledge
            if (!p.getName().equals(playerToUdate.getName())){
                ArrayList<List<Integer>> combinatory = getCombinatory(playerToUdate, p);
                playerToUdate.getKnowledge().remove(p.getName());
                playerToUdate.getKnowledge().put(p.getName(), combinatory);
            }
        }
        //When the player turn ends he is not able to see the table anymore
        actualPlayer.getSeenCards().get("Table").set(0, 0);
        actualPlayer.getSeenCards().get("Table").set(0, 0);
        //printAllPlayersKnowledge();
    }

    private ArrayList<List<Integer>> getCombinatory(Player playerA, Player playerB) {
        ArrayList<List<Integer>> combinatory = new ArrayList();
        //If playerA know both cards of playerB
        if (!playerA.getSeenCards().get(playerB.getName()).contains(0)){
            combinatory.add(playerA.getSeenCards().get(playerB.getName()));
            return combinatory;
        }
        ArrayList<Integer> cardsVector = new ArrayList(this.cards);
        //Minus cards that the player've watched (owns, table and some maybe of the other players)
        for (Integer card : playerA.getListWachedCards()){
            cardsVector.remove(card);
        } 
        /*System.out.println("CardsA"+playerA.getCards());
        System.out.println("CardsTbale"+this.getTable().getCards());
        System.out.println("SeenCards"+playerA.getSeenCards().toString());
        System.out.println("Vector"+cardsVector);*/
        ICombinatoricsVector<Integer> initialVector = Factory.createVector(cardsVector);
        Generator<Integer> combinationGenerator = new SimpleCombinationGenerator<Integer>(initialVector, 2);
        for (ICombinatoricsVector<Integer> vector : combinationGenerator.generateAllObjects()){
            combinatory.add(vector.getVector());
        }
        //if a player A knows a card of player B The knowldege of player A about B will include this card
        if (playerA.getSeenCards().get(playerB.getName()).get(0)!=0){
            ArrayList<List<Integer>> combinatoryCopy = new ArrayList(combinatory);
            for (List<Integer> cards : combinatory){
                if (!cards.contains(playerA.getSeenCards().get(playerB.getName()).get(0)))
                  combinatoryCopy.remove(cards);  
            }
            return combinatoryCopy;
        }
        return combinatory;
    }

    public void playersayKempSignal(Player actualPlayer) {
        this.signals.remove(actualPlayer.getName());
        this.signals.put(actualPlayer.getName(), actualPlayer.getSecretWord());
    }
    
    public void removeLastPlayerSignal(Player p){
        this.signals.remove(p.getName());
        this.signals.put(p.getName(), "None");
    }

    public void playerBluffKemps(Player actualPlayer) {
     this.signals.remove(actualPlayer.getName());
        this.signals.put(actualPlayer.getName(), actualPlayer.getRandomWord());   
    }

    public Object getKemps() {
        return signals;
    }

    public String kempsReaction(Player actualPlayer) {
        Player oponentA = getOponents(actualPlayer).get(0);
        Player oponentB = getOponents(actualPlayer).get(1);
       if (partnerCorrectSignal(actualPlayer)){
           this.kempsCall.remove(actualPlayer.getName());
           this.kempsCall.put(actualPlayer.getName(), this.KEMPS);
            System.out.println("AAAA");
           return sayKemps();
       }
       else if (oponentSignal(oponentA)){
           if (actualPlayer.checkProbs(oponentA)){
                this.kempsCall.remove(actualPlayer.getName());
                this.kempsCall.put(actualPlayer.getName(), this.ANTI_KEMPS);
                System.out.println("BBB"+this.kempsCall.get(actualPlayer.getName()));
                return sayAntiKemps();
           }
       }
       else if (oponentSignal(oponentB)){
           if (actualPlayer.checkProbs(oponentA)){
                this.kempsCall.remove(actualPlayer.getName());
                this.kempsCall.put(actualPlayer.getName(), this.ANTI_KEMPS);
                System.out.println("CCC"+this.kempsCall.get(actualPlayer.getName()));
                return sayAntiKemps();
           }
            return sayAntiKemps();
        }
       return NOTHING;
    }

    private boolean partnerCorrectSignal(Player p) {
        return this.getSignals().get(getPartner(p).getName()).equals(p.getSecretWord());
    }
    
    public Player getPartner(Player p){
        int playerIndex = this.getPlayers().indexOf(p);
        Player playerPartner=null;

        if (playerIndex==0){
            playerPartner = this.getPlayers().get(3);
        }
        else if(playerIndex==1){
                playerPartner = this.getPlayers().get(2);
            }
        else if(playerIndex==2){
                playerPartner = this.getPlayers().get(1);
            }
        else if(playerIndex==3){
                playerPartner = this.getPlayers().get(0);
            }
        return playerPartner;
    }

    public Hashtable<String, String> getSignals() {
        return signals;
    }


    private String sayAntiKemps() {
        return this.ANTI_KEMPS;
    }

    private String sayKemps() {
        return this.KEMPS;
    }

    private boolean oponentSignal(Player oponentB) {
        return !this.getSignals().get(oponentB.getName()).equals("None");
    }

    public ArrayList<Player> getOponents(Player p) {
        int playerIndex = this.getPlayers().indexOf(p);
        ArrayList<Player> opponents = new ArrayList<Player>();
        if (playerIndex== 0 || playerIndex==3){
            opponents.add(this.players.get(1));
            opponents.add(this.players.get(2));
            return opponents;
        }
        opponents.add(this.players.get(0));
        opponents.add(this.players.get(3));
        return opponents;        
    }

    public Hashtable<String, String> getKempsCall() {
        return kempsCall;
    }

    public String getKEMPS() {
        return KEMPS;
    }

    public String getANTI_KEMPS() {
        return ANTI_KEMPS;
    }

    public String getNOTHING() {
        return NOTHING;
    }
    
    
    public ArrayList<List<Integer>> filterDuplicateds(ArrayList<List<Integer>> list) {
        return Utils.filterArrayList(list);
    } 

    public void setKempsCall(Hashtable<String, String> kempsCall) {
        this.kempsCall = kempsCall;
    }
    
}
