package model;


import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Set;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author s2655314
 */
public class Player {
    
    private ArrayList<Integer> cards;
    private Hashtable<String, ArrayList<List<Integer>>> knowledge;
    //this parameter it's not completl necessary, but it existance make an easier data management
    private Hashtable<String, List<Integer>> seenCards;
    private int cardsAmount;
    private String name;
    private String secretWord;
    private ArrayList<String> randomWords;

    public Player(String name, String secretWord) {
        this.secretWord=secretWord;
        this.cardsAmount = 2;
        this.cards = new ArrayList(cardsAmount);
        this.knowledge = new Hashtable();
        this.name = "Player"+name;
        this.seenCards = new Hashtable();
        this.randomWords= new ArrayList<>();
        randomWords.add("Strawerry");
        randomWords.add("Lemon");
        randomWords.add("Tulip");
        randomWords.add("Peach");
        randomWords.add("Coconut");
        
    }

    public ArrayList<Integer> getCards() {
        return cards;
    }

    public Hashtable<String, ArrayList<List<Integer>>> getKnowledge() {
        return knowledge;
    }
    

    public int getCardsAmount() {
        return cardsAmount;
    }

    public String getName() {
        return name;
    }

    public Hashtable<String, List<Integer>> getSeenCards() {
        return seenCards;
    }

    public void addWatchedCard(List<Integer> cardsTransaccion, Player actualPlayer) {
        //Case non cards wached yet [0,0]
        if (this.seenCards.get(actualPlayer.getName()).get(0)==0 && this.seenCards.get(actualPlayer.getName()).get(1)==0){
            //this.seenCards.get(actualPlayer.getName()).get(0) = 1;
            this.seenCards.get(actualPlayer.getName()).set(0, cardsTransaccion.get(1));
        }
        //Case all cards already watched [x,y]
        else if (this.seenCards.get(actualPlayer.getName()).get(0)!=0 && this.seenCards.get(actualPlayer.getName()).get(1)!=0){
            if (cardsTransaccion.get(0)==this.seenCards.get(actualPlayer.getName()).get(0)){
                this.seenCards.get(actualPlayer.getName()).set(0, cardsTransaccion.get(1));
            }
            else if (cardsTransaccion.get(0)==this.seenCards.get(actualPlayer.getName()).get(1)){
                this.seenCards.get(actualPlayer.getName()).set(1, cardsTransaccion.get(1));
            }
        }
        //Case one cards already watched, [x,0]
        else{
            if (this.seenCards.get(actualPlayer.getName()).get(0)!=0){
                if (this.seenCards.get(actualPlayer.getName()).get(0)!=cardsTransaccion.get(0))
                    this.seenCards.get(actualPlayer.getName()).set(1, cardsTransaccion.get(1)); 
                else{
                    int descartedCard = cardsTransaccion.get(0);
                    if (cardTwoTimesInsideWatchedCards(descartedCard))
                        this.seenCards.get(actualPlayer.getName()).set(0, cardsTransaccion.get(1)); 
                }
            }
            else if (this.seenCards.get(actualPlayer.getName()).get(1)!=0){
                if (this.seenCards.get(actualPlayer.getName()).get(1)!=cardsTransaccion.get(0))
                    this.seenCards.get(actualPlayer.getName()).set(0, cardsTransaccion.get(1)); 
                else{
                  int descartedCard = cardsTransaccion.get(0);
                    if (cardTwoTimesInsideWatchedCards(descartedCard))
                        this.seenCards.get(actualPlayer.getName()).set(1, cardsTransaccion.get(1));   
                }
            }
        }
        //Own Cards
        this.seenCards.remove(this.getName());
        this.seenCards.put(this.getName(), this.getCards());
    }

    private boolean cardInsideWatchedCards(int descartedCard) {
        
    Set<String> set = this.seenCards.keySet();
    String  str;
    Iterator<String> itr = set.iterator();
    while (itr.hasNext()) {
      str = itr.next();
      if (this.seenCards.get(str).get(0)==descartedCard || this.seenCards.get(str).get(1)==descartedCard)
          return false;
    }
    return true;
    }
    
    private boolean cardTwoTimesInsideWatchedCards(int descartedCard) {
    int countTimes=0;
    Set<String> set = this.seenCards.keySet();
    String  str;
    Iterator<String> itr = set.iterator();
    while (itr.hasNext()) {
      str = itr.next();
      if (this.seenCards.get(str).get(0)==descartedCard || this.seenCards.get(str).get(1)==descartedCard){
          countTimes++;
          if (countTimes==2)
            return false;
      }
    }
    return true;
    }

    public ArrayList<Integer> getListWachedCards() {
        ArrayList<Integer> watchedCards = new ArrayList();
        Set<String> set = this.seenCards.keySet();
        String  str;
        Iterator<String> itr = set.iterator();
        while (itr.hasNext()) {
          str = itr.next();
          for (Integer card : this.seenCards.get(str)){
            watchedCards.add(card);
          }
        }
        return watchedCards;
        
    }

    public boolean hasPair() {
        return this.cards.get(0)==this.cards.get(1);
    }

    public String getSecretWord() {
        return secretWord;
    }

    public boolean thinkForBluffing(ArrayList<Player> players) {
        for (Player opponent : players){
            ArrayList<List<Integer>> oponentKnowledge = this.knowledge.get(opponent.getName());
            double kempsProb = 0;
            for(List<Integer> k : oponentKnowledge){
                    kempsProb += giveProbs(this);
            }
            double prob = (double)kempsProb/(double)oponentKnowledge.size();
            if(prob > 0.2) return true;
        }
        return false;
    }

    public boolean randomBluffing() {
        Random rnd = new Random();
        return rnd.nextInt(10)<2;
    }

    public ArrayList<String> getRandomWords() {
        return randomWords;
    }
    
    public String getRandomWord(){
        Random rnd = new Random();
        return this.getRandomWords().get(rnd.nextInt(this.getRandomWords().size()));
    }

    public boolean checkProbs(Player opponentA) {
        ArrayList<List<Integer>> oponentKnowledge = this.knowledge.get(opponentA.getName());
        int total = 0;
        int kemps = 0;
        for(List<Integer> k : oponentKnowledge){
            if(k.get(0)==k.get(1))
                kemps++;
            total++;
        }
        double prob = (double)kemps/(double)total;
        return prob > 0.2;
    }
    
    public double giveProbs(Player opponentA) {
        ArrayList<List<Integer>> oponentKnowledge = this.knowledge.get(opponentA.getName());
        int total = 0;
        int kemps = 0;
        for(List<Integer> k : oponentKnowledge){
            if(k.get(0)==k.get(1))
                kemps++;
            total++;
        }
        double prob = (double)kemps/(double)total;
        return prob;
    }
}
